# -*- coding: utf-8 -*-

import names
from custom_file_vp_qtableview import test_vp_qtableview_exact, test_vp_qtableview_some_rows


def main():
    startApplication("addressbook")
    clickButton(waitForObject(names.address_Book_New_QToolButton))
    add_dummy_entries()


    qtv = waitForObject({"type": "QTableView", "visible": 1})

    test_vp_qtableview_exact(squishinfo.testCase + "/verificationPoints/VP_QTableView_exact_fail.txt", qtv)
    test_vp_qtableview_exact(squishinfo.testCase + "/verificationPoints/VP_QTableView_exact_pass.txt", qtv)

    test_vp_qtableview_some_rows(squishinfo.testCase + "/verificationPoints/VP_QTableView_some_rows_fail.txt", qtv)
    test_vp_qtableview_some_rows(squishinfo.testCase + "/verificationPoints/VP_QTableView_some_rows_pass.txt", qtv)
    test_vp_qtableview_some_rows(squishinfo.testCase + "/verificationPoints/VP_QTableView_more_expected_than_actual_fail.txt", qtv)

    return


def add_dummy_entries():
    for i in range(6, 0, -1):
        add_entry("Black%s" % (i), "Sheep%s" % (i), "sheepish@black%s.com" % (i), "5554444-%s" % (i))
        mouseClick(waitForObjectItem(names.address_Book_File_QTableWidget, "0/0", 1))


def add_entry(forname, surname, email, phone):
    clickButton(waitForObject(names.address_Book_Unnamed_Add_QToolButton))
    type(waitForObject(names.forename_LineEdit), forname)
    mouseClick(waitForObject(names.surname_LineEdit), 10, 6, Qt.NoModifier, Qt.LeftButton)
    type(waitForObject(names.surname_LineEdit), surname)
    mouseClick(waitForObject(names.email_LineEdit), 14, 9, Qt.NoModifier, Qt.LeftButton)
    type(waitForObject(names.email_LineEdit), email)
    mouseClick(waitForObject(names.phone_LineEdit), 13, 7, Qt.NoModifier, Qt.LeftButton)
    type(waitForObject(names.phone_LineEdit), phone)
    clickButton(waitForObject(names.address_Book_Add_OK_QPushButton))
